opssh 3.6 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134
  1. #!/bin/bash
  2. # vim: expandtab:tabstop=4:shiftwidth=4
  3. function usage() {
  4. cat << EOF
  5. Usage: opssh [OPTIONS] command [...]
  6. Options:
  7. --version show program's version number and exit
  8. --help show this help message and exit
  9. -l USER, --user=USER username (OPTIONAL)
  10. -p PAR, --par=PAR max number of parallel threads (OPTIONAL)
  11. --outdir=OUTDIR output directory for stdout files (OPTIONAL)
  12. --errdir=ERRDIR output directory for stderr files (OPTIONAL)
  13. -e ENV, --env ENV which environment to use
  14. -t HOST_TYPE, --host-type HOST_TYPE
  15. which host type to use
  16. --list-host-types list all of the host types
  17. --timeout=TIMEOUT timeout (secs) (0 = no timeout) per host (OPTIONAL)
  18. -O OPTION, --option=OPTION
  19. SSH option (OPTIONAL)
  20. -v, --verbose turn on warning and diagnostic messages (OPTIONAL)
  21. -A, --askpass Ask for a password (OPTIONAL)
  22. -x ARGS, --extra-args=ARGS
  23. Extra command-line arguments, with processing for
  24. spaces, quotes, and backslashes
  25. -X ARG, --extra-arg=ARG
  26. Extra command-line argument
  27. -i, --inline inline aggregated output and error for each server
  28. --inline-stdout inline standard output for each server
  29. -I, --send-input read from standard input and send as input to ssh
  30. -P, --print print output as we get it
  31. Example: opssh -t ex-srv -e stg -l irb2 --outdir /tmp/foo uptime
  32. EOF
  33. }
  34. if [ $# -eq 0 ] || [ "$1" == "--help" ]
  35. then
  36. usage
  37. exit 1
  38. fi
  39. # See if ohi is installed
  40. if ! which ohi &>/dev/null ; then
  41. echo "ERROR: can't find ohi (OpenShift Host Inventory) on your system, please either install the openshift-ansible-bin package, or add openshift-ansible/bin to your path."
  42. exit 10
  43. fi
  44. PAR=200
  45. USER=root
  46. TIMEOUT=0
  47. ARGS=()
  48. ENV=""
  49. HOST_TYPE=""
  50. while [ $# -gt 0 ] ; do
  51. case $1 in
  52. -t|--host-type)
  53. shift # get past the option
  54. HOST_TYPE=$1
  55. shift # get past the value of the option
  56. ;;
  57. -e)
  58. shift # get past the option
  59. ENV=$1
  60. shift # get past the value of the option
  61. ;;
  62. --timeout)
  63. shift # get past the option
  64. TIMEOUT=$1
  65. shift # get past the value of the option
  66. ;;
  67. -p|--par)
  68. shift # get past the option
  69. PAR=$1
  70. shift # get past the value of the option
  71. ;;
  72. -l|--user)
  73. shift # get past the option
  74. USER=$1
  75. shift # get past the value of the option
  76. ;;
  77. --list-host-types)
  78. ohi --list-host-types
  79. exit 0
  80. ;;
  81. -h|--hosts|-H|--host|-o)
  82. echo "ERROR: unknown option $1"
  83. exit 20
  84. ;;
  85. *)
  86. args+=("$1")
  87. shift
  88. ;;
  89. esac
  90. done
  91. # Get host list from ohi
  92. if [ -n "$ENV" -a -n "$HOST_TYPE" ] ; then
  93. HOSTS="$(ohi -t "$HOST_TYPE" -e "$ENV" 2>/dev/null)"
  94. OHI_ECODE=$?
  95. elif [ -n "$ENV" ] ; then
  96. HOSTS="$(ohi -e "$ENV" 2>/dev/null)"
  97. OHI_ECODE=$?
  98. elif [ -n "$HOST_TYPE" ] ; then
  99. HOSTS="$(ohi -t "$HOST_TYPE" 2>/dev/null)"
  100. OHI_ECODE=$?
  101. else
  102. echo
  103. echo "Error: either -e or -t must be specified"
  104. echo
  105. exit 10
  106. fi
  107. if [ $OHI_ECODE -ne 0 ] ; then
  108. echo
  109. echo "ERROR: ohi failed with exit code $OHI_ECODE"
  110. echo
  111. echo "This is usually caused by a bad value passed for host-type or environment."
  112. echo
  113. exit 25
  114. fi
  115. exec pssh -t $TIMEOUT -p $PAR -l $USER -h <(echo "$HOSTS") "${args[@]}"